%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% k Approximation code - some strategy - others may work better
% For relational models as obtained by RGLVQ
%
% (C) Frank-Michael Schleif
% University of Bielefeld
% fschleif@techfak.uni-bielefeld.de
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [mAlphaKApprox] = fKApprox(mAlpha,mDistances,iK,fDistPtrRange)
        iNrPrototypes = size(mAlpha,1);
        N             = size(mDistances,1);
        iK            = min(iK,N);
        mDists                   = zeros(iNrPrototypes,N);
        for(k=1:iNrPrototypes)
            vNonZeros = (find(mAlpha(k,:)>1e-5)); %mAlpha(k,vNonZeros) * mDistances(vNonZeros,vNonZeros) * mAlpha(k,vNonZeros)';
            vAlpha    = mAlpha(k,vNonZeros);
            mDists(k,:)  = fDistPtrRange(vAlpha,[1:N],vNonZeros);                    
        end
        mDists(mDists<0) = 0;
        mAlphaKApprox = zeros(iNrPrototypes,N);
        for(k=1:iNrPrototypes)
            [Ydists,Idists] = sort(mDists(k,:));
            IkIndices       = Idists(1:iK);
            vWeights        = 1.0./max(Ydists(IkIndices),realmin);
            vWeights        = vWeights./sum(vWeights);
            mAlphaKApprox(k,IkIndices) = vWeights;
        end
          